From 25abe64483752f7585ae17b699167b0abe849833 Mon Sep 17 00:00:00 2001
From: TheWitness <thewitness@cacti.net>
Date: Fri, 13 Mar 2020 18:49:28 -0400
Subject: [PATCH] Fixing Issue #3343 and outstanding issue with #3342

---
 CHANGELOG            |  3 ++-
 auth_profile.php     | 11 +++++++++--
 include/layout.js    | 24 ++++++++++++++++--------
 lib/auth.php         | 20 ++++++++++++++++++++
 logout.php           |  9 ++++-----
 user_group_admin.php |  4 ++++
 6 files changed, 55 insertions(+), 16 deletions(-)

diff --git a/auth_profile.php b/auth_profile.php
index ca35554ce..255f7216a 100644
--- a/auth_profile.php
+++ b/auth_profile.php
@@ -616,7 +616,10 @@ function() {
 				value = $(this).val();
 			}
 
-			$.get('auth_profile.php?tab='+currentTab+'&action=update_data&name='+name+'&value='+value, function() {
+			$.post('auth_profile.php?tab='+currentTab+'&action=update_data', {
+				__csrf_magic: csrfMagicToken,
+				name: name,
+				value: value
 			});
 		}).change(function() {
 			name  = $(this).attr('id');
@@ -630,7 +633,11 @@ function() {
 				value = $(this).val();
 			}
 
-			$.get('auth_profile.php?tab='+currentTab+'&action=update_data&name='+name+'&value='+value, function() {
+			$.post('auth_profile.php?tab='+currentTab+'&action=update_data', {
+				__csrf_magic: csrfMagicToken,
+				name: name,
+				value: value
+				}, function() {
 				if (name == 'selected_theme' || name == 'user_language') {
 					document.location = 'auth_profile.php?action=edit';
 				}
diff --git a/include/layout.js b/include/layout.js
index e1e90c2a4..01d2d370f 100644
--- a/include/layout.js
+++ b/include/layout.js
@@ -760,7 +760,11 @@ function renderLanguages() {
 				var value = $(this).val();
 				var page  = basename(location.pathname);
 				if (page == 'auth_profile.php') {
-					$.get('auth_profile.php?tab='+currentTab+'&action=update_data&name='+name+'&value='+value, function() {
+					$.post('auth_profile.php?tab='+currentTab+'&action=update_data', {
+						__csrf_magic: csrfMagicToken,
+						name: name,
+						value: value
+						}, function() {
 						if (name == 'selected_theme' || name == 'user_language') {
 							document.location = 'auth_profile.php?action=edit';
 						}
@@ -1683,20 +1687,20 @@ function loadTopTab(href, id, force) {
 
 		$.ajaxQ.abortAll();
 		$.get(url)
-			.done(function(html) {
-				var htmlObject  = $(html);
-				var matches     = html.match(/<title>(.*?)<\/title>/);
+			.done(function(data) {
+				var htmlObject  = $(data);
+				var matches     = data.match(/<title>(.*?)<\/title>/);
 
 				if (matches != null) {
 					var htmlTitle   = matches[1];
 					var breadCrumbs = htmlObject.find('#breadcrumbs').html();
-					var parts       = html.split('</title>');
+					var parts       = data.split('</title>');
 					var data        = parts[1];
 
 					checkForLogout(data);
 
 					$('title').text(htmlTitle);
-					$('#breadcrumbs').html(breadCrumbs);
+					$('#breadcrumbs').data(breadCrumbs);
 					$('div[class^="ui-"]').remove();
 					$('#cactiContent').replaceWith(data);
 
@@ -1707,9 +1711,9 @@ function loadTopTab(href, id, force) {
 
 					pushState(myTitle, href);
 				} else {
-					checkForLogout(html);
+					checkForLogout(data);
 
-					$('#cactiContent').replaceWith(html);
+					$('#cactiContent').replaceWith(data);
 
 					thref = stripHeaderSuppression(href);
 
@@ -2827,9 +2831,13 @@ function checkForLogout(data) {
 		return true;
 	} else if (typeof data === 'object') {
 		return true;
+	} else if (data.indexOf('cactiLoginSuspend') >= 0) {
+		document.location = urlPath + 'logout.php?action=disabled';
 	} else if (data.indexOf('cactiLoginLogo') >= 0) {
 		document.location = urlPath + 'logout.php?action=timeout';
 	}
+
+	return false;
 }
 
 function clearGraphFilter() {
diff --git a/lib/auth.php b/lib/auth.php
index 7c4f4552c..e03da9f13 100644
--- a/lib/auth.php
+++ b/lib/auth.php
@@ -324,6 +324,8 @@ function user_disable($user_id) {
 	/* ==================================================== */
 
 	db_execute_prepared("UPDATE user_auth SET enabled = '' WHERE id = ?", array($user_id));
+
+	reset_user_perms($user_id);
 }
 
 /* user_enable - enable a user account
@@ -334,6 +336,8 @@ function user_enable($user_id) {
 	/* ==================================================== */
 
 	db_execute_prepared("UPDATE user_auth SET enabled = 'on' WHERE id = ?", array($user_id));
+
+	reset_user_perms($user_id);
 }
 
 /* get_auth_realms - return a list of system user authentication realms */
@@ -687,6 +691,22 @@ function is_realm_allowed($realm) {
 			kill_session_var('sess_user_realms');
 			kill_session_var('sess_user_config_array');
 			kill_session_var('sess_config_array');
+
+			$enabled = db_fetch_cell_prepared('SELECT enabled
+				FROM user_auth
+				WHERE id = ?',
+				array($_SESSION['sess_user_id']));
+
+			if ($enabled == '') {
+				db_execute_prepared('DELETE FROM user_auth_cache
+					WHERE user_id = ?',
+					array($_SESSION['sess_user_id']));
+
+				kill_session_var('sess_user_id');
+
+				print '<span style="display:none;">cactiLoginSuspend</span>';
+				exit;
+			}
 		}
 
 		if (isset($_SESSION['sess_user_realms'][$realm])) {
diff --git a/logout.php b/logout.php
index 93c7b3d59..c73c2af6c 100644
--- a/logout.php
+++ b/logout.php
@@ -75,9 +75,7 @@
 	include('./include/global_session.php');
 	print "</body>
 	</html>\n";
-} elseif (read_config_option('auth_method') == '2') {
-	clear_auth_cookie();
-
+} elseif (get_request_var('action') == 'disabled') {
 	print "<!DOCTYPE HTML PUBLIC '-//W3C//DTD HTML 4.01 Transitional//EN' 'http://www.w3.org/TR/html4/loose.dtd'>\n";
 	print "<html>\n";
 	print "<head>\n";
@@ -91,14 +89,15 @@
 	<div class='logoutLeft'></div>
 	<div class='logoutCenter'>
 		<div class='logoutArea'>
-			<div class='cactiLogoutLogo'></div>
+			<div class='cactiLogoutLogo cactiLoginSuspend'></div>
 			<legend>" . __('Automatic Logout') . "</legend>
 			<div class='logoutTitle'>
-				<p>" . __('You have been logged out of Cacti due to a session timeout.') . "</p>
+				<p>" . __('You have been logged out of Cacti due to an account suspension.') . "</p>
 				<p>" . __('Please close your browser or %sLogin Again%s', '</p><center>[<a href="index.php">', '</a>]</center>') . "
 			</div>
 			<div class='logoutErrors'></div>
 		</div>
+		<div class='versionInfo'>" . __('Version %s', $version) . " | " . COPYRIGHT_YEARS_SHORT . "</div>
 	</div>
 	<div class='logoutRight'></div>
 	<script type='text/javascript'>
diff --git a/user_group_admin.php b/user_group_admin.php
index 4526284ed..7f3de7d88 100644
--- a/user_group_admin.php
+++ b/user_group_admin.php
@@ -183,10 +183,14 @@
 
 function user_group_disable($id) {
 	db_execute_prepared("UPDATE user_auth_group SET enabled = '' WHERE id = ?", array($id));
+
+	reset_group_perms($id);
 }
 
 function user_group_enable($id) {
 	db_execute_prepared("UPDATE user_auth_group SET enabled = 'on' WHERE id = ?", array($id));
+
+	reset_group_perms($id);
 }
 
 function user_group_remove($id) {
